#!/bin/bash
# KMI (jld) 

CP="/usr/rock/SMARTSDist/lib"
KMI1HZ="/proc/kmi1hz"
T1RESULT="FAIL"
T2RESULT="FAIL"
PORT=""

Cleanup ()
{
   echo "N" | pssetparams SensorPwr=0 > /dev/null 2>&1
   gpsoptmode 0
}

if [ "$1" == "" ]; then
    echo "Usage: ATGGPSTest.sh [l|m|r|port]"
    exit 9
fi

trap "Cleanup" EXIT

clear
echo "Turning sensor power on..."
echo "N" | pssetparams SensorPwr=1 > /dev/null 2>&1
echo "Setting GPS board mode..."
gpsoptmode 2
sleep 5

PORT="$1"

case $PORT in
    L|l )
        PORT="/dev/ttyS5"
        ;;

    M|m )
        PORT="/dev/ttyS4"
        ;;

    R|r )
        PORT="/dev/ttyS3"
        ;;
esac

java -cp $CP/kmitools.jar:$CP/kmitrimble.jar:$CP/Serialio.jar kmi.trimble.ATGIOManager "$PORT"
[ $? == 0 ] && T1RESULT="PASS"

if [ -f "$KMI1HZ" ]; then
    REPLY=`cat $KMI1HZ`
    [ "$REPLY" != "" ] && T2RESULT="PASS"
fi

echo
echo "GPS I/O: $T1RESULT"
echo "GPS 1HZ: $T2RESULT"
echo

if [ "$T1RESULT" == "PASS" ] && [ "$T2RESULT" == "PASS" ]; then
    exit 0
fi

exit 1

