#!/bin/bash

CP="/usr/rock/SMARTSDist/lib"
T1RESULT="FAIL"

Cleanup ()
{
   echo "N" | pssetparams SensorPwr=0 > /dev/null 2>&1
}

if [ "$1" == "" ]; then
    echo "Usage: MZD24Test.sh [l|m|r|port]"
    exit 9
fi

trap "Cleanup" EXIT

clear
echo "Turning sensor power on..."
echo "N" | pssetparams SensorPwr=1 > /dev/null 2>&1
echo "Setting MZ485 board mode..."
mz485ppsmode 0
sleep 5

PORT="$1"

case $PORT in
    L|l )
        PORT="/dev/ttyS5"
        ;;

    M|m )
        PORT="/dev/ttyS4"
        ;;

    R|r )
        PORT="/dev/ttyS3"
        ;;
esac


java -cp $CP/kmitools.jar:$CP/kmimzd24.jar:$CP/kmitrimble.jar:$CP/Serialio.jar kmi.mzd24.MZD24Group "$PORT"
ECODE=$?

[ $ECODE == 0 ] && T1RESULT="PASS"

echo
echo "MZD24 I/O: $T1RESULT"
echo

exit $ECODE
