% KMI MatLab Plot Script

if isempty(who('MLChVars'))

    msgbox('Nothing to plot. Please load your KMI data file first.');

else

    nChan = length(MLChVars);
    choices = MLChVars;

    for i = 1:nChan

        chVarStr = MLChVars(i);
        spsVar = strcat(chVarStr, '_SPS');
        sps = eval(cell2mat(spsVar));
        choices(i) = cellstr([cell2mat(choices(i)), '    ', num2str(sps), ' sps']);

    end

    selectionIndex = listdlg('Name', 'KMI Plot', 'PromptString', 'Select a Channel to Plot', 'SelectionMode', 'single', 'ListString', choices);

    if (selectionIndex > 0)

        chVarStr = MLChVars(selectionIndex);
        y = eval(cell2mat(chVarStr));
        nSamp = length(y);
        spsVar = strcat(chVarStr, '_SPS');
        sps = eval(cell2mat(spsVar));
        x = 0:1/sps:(nSamp-1)/sps;
        chName = cell2mat(strrep(chVarStr, '_', ' '));
        plot(x,y);
        xlabel('Time (sec.)', 'FontWeight', 'bold');
        ylabel('ADC Counts', 'FontWeight', 'bold');
        title([chName,  ',  ', num2str(sps), 'sps, ', NetworkId, '-', StationId, ', ', MLStartTime], 'BackgroundColor', 'y', 'FontWeight', 'bold');
        zoom xon;
        grid on;

    end

end


