@echo off

title Rockhound

if exist "%JavaRoot%"\winrun.bat cd "%JavaRoot%"

:: Set up the path for JVM and Java Utilities
:: ------------------------------------------
set CPATH=%JavaRoot%;%JavaRoot%\classes;%JavaRoot%\lib;%JavaRoot%\lib\kmitools.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmialtus.jar;%JavaRoot%\lib\kmismartslib.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmiseismic.jar;%JavaRoot%\lib\kmirock.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmijsupport.jar;%JavaRoot%\lib\kmiregistration.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmiq330.jar;%JavaRoot%\lib\kmiorb.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmiguiutil.jar;%JavaRoot%\lib\kmiparameditor.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmismartsapp.jar;%JavaRoot%\lib\kmifiltergen.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmismartsvscope.jar;%JavaRoot%\lib\kmismartsguilib.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmifilepoll.jar;%JavaRoot%\lib\kmismartstalk.jar
set CPATH=%CPATH%;%JavaRoot%\lib\kmiomegapio.jar

:STARTSMARTS

cls
:: echo Starting Kinemetrics SMARTS
:: echo Copyright (c) 2000-2004, Kinemetrics, Inc.

:: Move the latest dll's into the system32 dir
:: ---------------------------------------------------------------------
if not exist lib\kmi*.dll goto ENDDLLMOVE
copy lib\kmi*.dll %SystemRoot%\system32\ > NUL
del lib\kmi*.dll > NUL
:ENDDLLMOVE

:: Has a SMARTS software update been loaded into the injar directory?
:: -----------------------------------------------------------------
if not exist injar\update.jar goto NOUPDATEREQUIRED

:: Since an update is required, let's see if we need to shuffle versions
:: ---------------------------------------------------------------------
if not exist ..\update.jar goto NOOLDTOSAVE

:: Save current as possible next "previous" in case I need to restore
:: ------------------------------------------------------------------
copy ..\update.jar injar\update.jar.save

:NOOLDTOSAVE

:: Move it out to the parent directory
:: -----------------------------------
copy injar\update.jar ..\update.jar
if exist done.tag del done.tag
if exist cust.tag del cust.tag

:: Move out to the parent directory
:: --------------------------------
cd ..

:: Unjar the new software
:: ----------------------
java sun.tools.jar.Main xvf update.jar

:: Move back into the execution directory
:: --------------------------------------
cd SMARTSDist
if exist kmi*.jar del kmi*.jar

:: Make sure unjar succeeded
:: -------------------------
if exist done.tag goto UPDATEOK

:: Delete the one that didn't open, put back one that worked, and restart
:: ----------------------------------------------------------------------
del ..\update.jar
del injar\update.jar
ren injar\update.jar.save update.jar
goto STARTSMARTS

:UPDATEOK

:: Update complete
:: ---------------
del injar\update.jar
if exist injar\update.jar.prev del injar\update.jar.prev
if exist injar\update.jar.save del injar\update.jar.save

:: Start the new batch file
:: ------------------------
start winrun.bat

:: Exit the old stuff
:: ------------------
exit

:NOUPDATEREQUIRED

:: Real execution loops are in WINRERUN.BAT
:: ----------------------------------------
if not "%1"=="" goto NOTFIRSTRUN

:: Copy the batch file so that when really running, we're in a safe, private copy
:: of the batch file that won't be overwritten on an update
:: --------------------------------------------------------
copy winrun.bat winrerun.bat

:: Run the safe, private copy
:: --------------------------
start winrerun.bat SAFE

:: Exit the old stuff
:: ------------------
exit

:NOTFIRSTRUN

:: Make sure at least some configuration exists
:: --------------------------------------------
if exist config\config.jar goto HASACONFIG

echo No configuration found, copying basic communication config...

:: Copy a console only as the config to start
:: ------------------------------------------
copy config\consoleonly.jar injar\config.jar

:HASACONFIG

:: Is there a new config file because of a config change?
:: ------------------------------------------------------
if not exist injar\config.jar goto NONEWCONFIG

echo New configuration found, setting it up...

:: Since new config exists, let's see if we need to shuffle versions
:: -----------------------------------------------------------------
if not exist config\config.jar goto NOCURRENTCONFIGTOSAVE

:: Save current in case I need to put it back
:: ------------------------------------------
copy config\config.jar injar\config.jar.save

:NOCURRENTCONFIGTOSAVE

:: Copy the new config from injar into the config directory
:: --------------------------------------------------------
copy injar\config.jar config
del config\done.tag

:: Move into the config directory
:: ------------------------------
cd config

:: Unjar the new config stuff
:: --------------------------
del pluginlo\*.cfg
del plugins\*.plg
java sun.tools.jar.Main xvf config.jar

:: Pop back to the execution directory
:: -----------------------------------
cd ..

:: Make sure the config succeeded
:: ------------------------------
if exist config\done.tag goto NEWCONFIGOK

:: Delete the one that didn't open, put back one that worked, and restart
:: ----------------------------------------------------------------------

del config\config.jar
del injar\config.jar
ren injar\config.jar.save config.jar
goto HASACONFIG
 
:NEWCONFIGOK

:: Delete the config from the injar
:: --------------------------------
del injar\config.jar
if exist injar\config.jar.prev del injar\config.jar.prev
if exist injar\config.jar.save del injar\config.jar.save

:: Delete the transient config information
:: ---------------------------------------
del config\transient.cfg

:NONEWCONFIG

:: Delete exit.cfg before starting. Mainly used by TestSequencer.
:: --------------------------------------------------------------
if exist exit.cfg del reporting.bat
if exist exit.cfg del exit.cfg

:: Start test mode window if test mode. Regular console if non-Test mode.
:: ----------------------------------------------------------------------
if exist testmode.cfg goto TESTMODE
java -Xmx256m -Dsun.java2d.noddraw=true -classpath "%CPATH%" kmi.smarts.app.SMARTSApp
goto AFTERJVMCOMPLETED
:TESTMODE
:: Turn off BIOS time sync
:: -----------------------
SysTimeAdjCtl 0
java -Xmx256m -Dsun.java2d.noddraw=true -classpath "%CPATH%" kmi.smarts.app.SMARTSApp -stdiowin
:AFTERJVMCOMPLETED

bin\sleep 5

:: Exit batch file if exit.cfg exists. Mainly used by TestSequencer.
:: ----------------------------------------------------------------
if not exist exit.cfg goto NOEXITNOW
if exist reporting.bat SysTimeAdjCtl 1
if exist reporting.bat start reporting.bat
if exist exit.cfg exit

:NOEXITNOW

goto STARTSMARTS